/* WarpVision Updater (Use at your own risk!)                  */
/* Created by Salvador Parra Camacho (x3265340@fedro.ugr.es)   */
/* Web page: http://www.geocities.com/escajarro                */
/* WARNING: This version is un-tested!                         */

/* Load the RexxUtil Functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''

working_dir = directory()

/* Load the configuration file */
if load_cfg() = '1' then
do
    say '  WVU configuration file not found!'
    say ''
    exit
end

if configurated='no' then
do
    say '  WVU not configurated yet!'
    say '  Please, open and edit the configuration file.'
    exit
end

/* Load the log file */
wvgui = '0'
wvcli = '0'
wvskins_list = 'default'
do while lines('wvu.log')>0
    current_line = strip(linein('wvu.log'),'T')
    interpret current_line
end
call lineout 'wvu.log'

/* Load the RxFtp Functions */
call RxFuncAdd 'FtpLoadFuncs', 'rxFtp', 'FtpLoadFuncs'
call FtpLoadFuncs 'BypassCopyright'

/* Shows the special message */
call support_warpin

/* Connecting to the FTP server */
rc = FtpSetUser(host,user,password)

/* Download WarpVision GUI */
call directory(download_wvgui_dir)
if download_new_wvgui = 'yes' then call down_wvgui
if delete_downloads='yes' then
	'@del wvgui'||wvgui||'.zip 2>NUL'
call directory(working_dir)

/* Download WarpVision Skins */
call directory(download_skins_dir)
if download_new_skins = 'yes' then call down_skins
call directory(working_dir)

/* Download WarpVision CLI */
call directory(download_wvgui_dir)
if download_new_wvcli = 'yes' then call down_wvcli
if delete_downloads='yes' then
	'@del wvcli'||wvcli||'.zip 2>NUL'
call directory(working_dir)

/* Creates the WVU program object */
call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''
say '  Creating or Updating WVU program object'
parse source . . wvu
call SysCreateObject 'WPProgram', 'WarpVision Updater', '<WP_DESKTOP>',,
                     'EXENAME='||wvu||';OBJECTID=<WVU>', 'Update'
say ''
say '  Press any key to continue.'
call SysGetKey('NOECHO')

/* Installs WarpVision GUI */
call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''
call directory(download_wvgui_dir)
if install_wvgui='yes' then
do
say '  Installing WarpVision GUI.'
say ''
'@del '||wvgui_dir||'\VIDEO2.INI 2>NUL'
'@'||unzip_program||' -uo wvgui'||wvgui||'.zip -d '||wvgui_dir
end
call directory(working_directory)
say ''
say '  Press any key to continue.'
call SysGetKey('NOECHO')
/* Installs WarpVision CLI */
call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''
call directory(download_wvcli_dir)
if install_wvcli='yes' then
do
say '  Installing WarpVision CLI.'
say ''
'@'||unzip_program||' -uo wvcli'||wvcli||'.zip -d '||wvcli_dir
end
call directory(working_directory)
say ''
say '  Press any key to continue.'
call SysGetKey('NOECHO')

/* Creates WarpVision GUI program object */
call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''
say '  Creating or Updating program object'
setup_string = 'EXENAME='||wvgui_dir||'\VIDEO2.EXE;OBJECTID=<WVGUI>'
setup_string = setup_string||';ASSOCFILTER='||assocfilter

call SysCreateObject 'WPProgram', 'WarpVision GUI', '<WP_DESKTOP>',,
                     setup_string,,
                     'Update'
say ''
say '  Press any key to continue.'
call SysGetKey('NOECHO')

/* Advanced association system */
if associations='yes' then
	call magic_ass

exit

/********************************************************************/
/* Load configuration file function */

load_cfg:
if stream('wvu.cfg','c','query exists') = '' then return 1

do while lines('wvu.cfg')>0
	current_line = strip(linein('wvu.cfg'),'T')
	first_char = left(current_line,1)
 	select
            when first_char = ';' | first_char = ' ' then
                nop
            when first_char = '[' then
                nop
            otherwise
                interpret current_line
	end
end

call lineout 'wvu.cfg'
return 0

/* Download WVGUI procedure */

down_wvgui:
rc = FtpChDir(wvgui_ftp)

rc = FtpLs('wvgui*.zip', wvgui.)

version = '0'

do i = 1 to wvgui.0
	string = substr(wvgui.i, lastpos('wvgui', wvgui.i)+5)
	version_number = delstr(string,lastpos('.',string))
	version = max(version, version_number)
end

call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''

if version > wvgui then
	do
	say '  Found a new version of WarpVision GUI!'
	say '  Downloading wvgui'||version||'.zip'
	rc = FtpGet('wvgui'||version||'.zip','wvgui'||version||'.zip','BINARY')
	wvgui = version
	call writelog
	say '  File downloaded.'
	end
else
	say '  New versions of WarpVision GUI not found'

say '  Press any key to continue.'
call SysGetKey('NOECHO')

rc = FtpChDir('..')
return

/* Download WVCLI procedure */

down_wvcli:
rc = FtpChDir(wvcli_ftp)

rc = FtpLs('wvcli*.zip', wvcli.)

version = '0'

do i = 1 to wvcli.0
	string = substr(wvcli.i, lastpos('wvgui', wvcli.i)+5)
	version_number = delstr(string,lastpos('.',string))
	version = max(version, version_number)
end

call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''

if version > wvcli then
	do
	say '  Found a new version of WarpVision CLI!'
	say '  Downloading wvcli'||version||'.zip'
	rc = FtpGet('wvcli'||version||'.zip','wvcli'||version||'.zip','BINARY')
	wvcli = version
	call writelog
	say '  File downloaded.'
	end
else
	say '  New versions of WarpVision CLI not found'

say '  Press any key to continue.'
call SysGetKey('NOECHO')
rc = FtpChDir('..')
return

/* Download Skins procedure */

down_skins:
rc = FtpChDir(wvskins_ftp)

rc = FtpLs('*.zip', wvskins.)

call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''

skins.0 = words(wvskins_list)

do k = 1 to skins.0
	skins.k = word(wvskins_list, k)
end

do i = 1 to wvskins.0
	do j = 0 to skins.0
		if wvskins.i = skins.j then
		download = 'no'
	end
	if download <> 'no' then
	do
	wvskins_list = wvskins_list||' '||wvskins.i
	found_skins = '1'
	say '  Found new skin of WarpVision GUI!'
	say '    Downloading '||wvskins.i
	rc = FtpGet(wvskins.i,wvskins.i,'BINARY')
	say '    File downloaded.'
	end
end

call writelog

if found_skins <> '1' then say '  New WarpVision skins not found'
say '  Press any key to continue.'
call SysGetKey('NOECHO')

rc = FtpChDir('..')
return

/* Write log file procedure */

writelog:
call charin 'wvu.log'
call lineout 'wvu.log','wvgui='||wvgui
call lineout 'wvu.log','wvcli='||wvcli
call lineout 'wvu.log',"wvskins_list='"||wvskins_list||"'"
call lineout 'wvu.log'
return

/* Shows the special message */
support_warpin:
call SysSleep 2
call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''
say '  This is the LAST release of this program.'
say "  I won't continue the development of this program."
say ''
say '  IMHO, if you want an simple updater program you must to'
say '  say that to the WarpIN Team. OS/2 needs a simple tool'
say '  for online installations (such APT -DEB or RPM based- in'
say '  Linux systems or the QNX operating system package'
say '  manager) and WarpIN is the best way to make that.'
say ''
say '  WarpVision Team IS NOT RESPONSIBLE OF THIS PROGRAM.'
say '  WarpIN Team IS NOT RESPONSIBLE OF THIS PROGRAM.'
say '  And, of course, I AM NOT RESPONSIBLE OF THE DAMAGES'
say '  THAT THIS PROGRAM CAN CAUSE IN YOUR MACHINE.'
say ''
say '  Best wishes:'
say '  Salvador Parra Camacho'
say '  (http://www.geocities.com/escajarro)'
call SysCurState 'OFF'
call SysSleep 30
call SysCurState 'ON'
call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''

return

/* Magic Association System */
magic_ass:
call SysCls
say ''
say '  WVU: WarpVision Updater'
say ''
say '  Now starts the association system.'
say '  - Classic associations by type not supported.'
say '  - XWP Extended associations not supported.'
say '  - Object Desktop icons (?) not supported.'
say ''
say '  Press any key to continue.'
call SysGetKey('NOECHO')

call RxFuncAdd 'WPToolsLoadFuncs', 'WPTOOLS', 'WPToolsLoadFuncs'
call WPToolsLoadFuncs
extensions = translate(assocfilter,' ',',')
extension.0 = words(extensions)
do i = 1 to extension.0
	extension.i = word(extensions,i)
	out ='out'
	do until out = ''
	call SysCls
	say ''
	say '  WVU: WarpVision Updater'
	say ''
	say '  List of program objects associated with '||extension.i||':'
	say ''
	handlers = SysIni('USER', 'PMWP_ASSOC_FILTER', extension.i)
	handlers = translate(handlers,'',x2c(00))
	handler.0 = words(handlers)
	do j = 1 to handler.0
		handler.j = word(handlers, j)
		hex_handler.j = d2x(handler.j)
		rc = WPToolsQueryObject('#'||hex_handler.j, ., 'title.j', ., .)
		say '  '||j||'. '||title.j||'.'
	end
	say ''
	say '  Press a number key to select a program object to move.'
	say '  u to up the WarpVision GUI.'
	say '  d to down the WarpVision GUI.'
	say '  e to erase the WarpVision GUI association'
	say '  s to save and continue.'
	say ''
	key = SysGetKey('NOECHO')
	select
		when key = 'u' then
		do
		end
		when key = 'd' then
		do
		end
		when key = 'e' then
		do
		end
		when key = 's' then
		do
		out = ''
		end
		otherwise nop
	end /* select */
	end
end

return

/********************************************************************/